//
// File: MySQLParser.h
// This code was produced by the dragon parser generator
//
#include <lfcbase/Exception.h>
#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>
#define MAXTOKENVAL 100

class MySQLParser
{

public:

   MySQLParser();
   virtual ~MySQLParser();

   void parse();
   ListT<Chain>& getTokenList() { return _tokenList; }

protected:

   virtual char nextChar() = 0;
   virtual void backChar() = 0;
   virtual void execInsert() = 0;
   virtual void execCreate() = 0;
   virtual void execDrop() = 0;
   virtual void dropOpt1() = 0;
   virtual void dropOpt2() = 0;
   virtual void storeAttrColumn() = 0;
   virtual void storeNotNullOpt() = 0;
   virtual void storeNullOpt() = 0;
   virtual void storeDefaultOpt() = 0;
   virtual void storeDefaultNullOpt() = 0;
   virtual void storePrimaryKey() = 0;
   virtual void storeUniqueKey() = 0;
   virtual void storeKey() = 0;
   virtual void storeKeyColumn() = 0;
   virtual void insertPreAction() = 0;
   virtual void insertPostAction() = 0;
   virtual void insertAttr() = 0;
   virtual void storeInsert() = 0;
   virtual void insertConstValue() = 0;
   virtual void storeTable() = 0;
   virtual void storeIntType() = 0;
   virtual void storeLongType() = 0;
   virtual void storeDecimalType() = 0;
   virtual void storeVarcharType() = 0;
   virtual void storeTimestampType() = 0;
   virtual void storeDatetimeType() = 0;
   virtual void storeDateType() = 0;
   virtual void storeMediumTextType() = 0;
   virtual void storeEnumType() = 0;
   virtual void storeCurrentTimestampValue() = 0;
   virtual void storeIntValue() = 0;
   virtual void storeNegIntValue() = 0;
   virtual void storeVarcharValue() = 0;
   virtual void storeNullValue() = 0;
   virtual void storeDim() = 0;
   virtual void storeDecimalDim() = 0;
   virtual void storeUnsignedType() = 0;
   virtual void procStore() = 0;
   virtual void procHead() = 0;
   virtual void procReturnOpt() = 0;
   virtual void procArg1() = 0;
   virtual void procStoreBlock() = 0;
   virtual void procDeclare() = 0;
   virtual void procAssign() = 0;
   virtual void procExpression() = 0;
   virtual void procInsert() = 0;
   virtual void procReturn1() = 0;
   virtual void procReturn2() = 0;
   virtual void procBlock() = 0;
   virtual void procBlockStart() = 0;
   virtual void procIf() = 0;
   virtual void procStoreIfBlock() = 0;
   virtual void procStoreElseBlock() = 0;
   virtual void procElsePart() = 0;
   virtual void procIfCondition() = 0;
   virtual void procElsIfCondition() = 0;
   virtual void procWhile() = 0;
   virtual void procWhileCondition() = 0;
   virtual void procCondition1() = 0;
   virtual void procCondition2() = 0;
   virtual void procCondition3() = 0;
   virtual void procPredicate1() = 0;
   virtual void procPredicate2() = 0;
   virtual void equalComp() = 0;
   virtual void notEqualComp() = 0;
   virtual void lessComp() = 0;
   virtual void moreComp() = 0;
   virtual void lessEqualComp() = 0;
   virtual void moreEqualComp() = 0;
   virtual void exprPlus() = 0;
   virtual void exprMinus() = 0;
   virtual void exprTerm() = 0;
   virtual void termStar() = 0;
   virtual void termDiv() = 0;
   virtual void termFactor() = 0;
   virtual void factorConst() = 0;
   virtual void factorIdentifier() = 0;
   virtual void factorFunction() = 0;
   virtual void factorExpr() = 0;

   enum Token {
      IDENTIFIER,
      FLOATVAL,
      INTVAL,
      AT,
      SEMICOLON,
      MT,
      LT,
      NEGATION,
      RB,
      LB,
      KSEP,
      EQU,
      DIVISION,
      STAR,
      MINUS,
      PLUS,
      WRITE,
      WHILE,
      WHERE,
      VARCHAR,
      VALUES,
      UPDATE,
      UNSIGNED,
      UNIQUE,
      UNLOCK,
      TIMESTAMP,
      THEN,
      TEXT,
      TABLES,
      TABLE,
      SET,
      SELECT,
      RETURNS,
      RETURNTOKEN,
      PRIMARY,
      OR,
      ON,
      NULLTOKEN,
      NOT,
      MEDIUMTEXT,
      LONGBLOB,
      LOCK,
      KEY,
      INSERT,
      INTO,
      INT,
      INDEX,
      IF,
      FUNCTION,
      FOREIGN,
      FLOAT,
      FALSEVAL,
      EXISTS,
      ENGINE,
      ENUM,
      ELSIF,
      ELSE,
      END_TOKEN,
      DROP,
      DOUBLE,
      DETERMINISTIC,
      DEFINER,
      DEFAULT,
      DECIMAL,
      DECLARE,
      DATETIME,
      DATE,
      CURRENTTIMESTAMP,
      CREATE,
      COLLATE,
      CHARSET,
      BOOL,
      BIGINT,
      BEGIN,
      AUTOINCREMENT,
      AND,
      STRINGVAL,
      ENDTOKEN
   };
   void setReserved(Token t);

private:

   enum Symbol { PROD, TOKEN, NONE };
   enum ScannerStateType { START, INTERMEDIATE, FINAL, ANY };
   enum Action { SHIFT, REDUCE, ACCEPT, NULLACTION };
   enum Production {
      Start,
      Statement,
      DropOpt,
      EngineOpt,
      AutoIncrementOpt,
      TableCharsetOpt,
      TableCollateOpt,
      ColumnList,
      NullOpt,
      DefaultNullOpt,
      DefaultOpt,
      DefaultDefOpt,
      IncrementOpt,
      OnUpdateOpt,
      ColumnDesc,
      KeyList,
      LockStatement,
      UnlockStatement,
      InsertPrefix,
      InsertStatement,
      InsertAttrSpec,
      InsertAttrList,
      InsertValueArray,
      InsertValueSpec,
      InsertValueList,
      InsertValue,
      UpdateStatement,
      UpdateSetList,
      UpdateSet,
      UpdateCondition,
      SelectStatement,
      Table,
      DataTypeProd,
      ConstList,
      Constant,
      DimOpt,
      DecimalDimOpt,
      UnsignedOpt,
      CollateOpt,
      FunctionStatement,
      ProcHeader,
      ReturnOpt,
      DeterministicOpt,
      DefinerOpt,
      ProcArgOpt,
      ProcArgList,
      ProcArg,
      ProcStmtBlock,
      ProcStatementList,
      ProcBlockStart,
      ProcIfPart,
      ProcElsIfList,
      ProcElsIfOpt,
      ProcElseOpt,
      ProcElsePart,
      ProcIfCondition,
      ProcElsIfCondition,
      ProcStatement,
      ProcWhileCondition,
      ProcCondition,
      ProcPredicate,
      Comparison,
      Expr,
      Term,
      Factor,
      FunctionCall,
      FuncArgList
   };
   void loadScanner();
   void loadParser0();
   void loadParser1();
   void loadParser2();
   void loadParser3();
   void loadParser4();
   void loadParser5();
   void loadParser6();
   void loadParser7();
   void loadParser8();
   void loadParser9();
   void loadParser10();
   void loadParser11();
   void loadParser12();
   void loadParser13();
   void loadParser14();
   void loadParser15();
   void loadParser16();
   void loadParser17();
   void loadParser18();
   void loadParser19();
   void loadParser20();
   void loadParser21();
   void loadParser22();
   void loadParser23();
   void loadParser24();
   void loadParser25();
   void loadParser26();
   void loadParser27();
   void loadParser28();
   void loadParser29();
   void loadParser30();
   void loadParser31();
   void loadParser32();
   void loadParser33();
   void loadParser34();

   class ScannerStateEntry {

   public:

      ScannerStateEntry();
      ScannerStateEntry(int state, ScannerStateType type = INTERMEDIATE);
      ScannerStateEntry& operator = (const ScannerStateEntry& s);
      bool operator == (const ScannerStateEntry& s);

	   int getState();
      ScannerStateType getType();

   private:

      int _state;
      ScannerStateType _type;
   };

class ScannerTransEntry {

   public:

      ScannerTransEntry();
      ScannerTransEntry(int state, char c);
      ScannerTransEntry(int state, char c, int fstate);
      ScannerTransEntry& operator = (const ScannerTransEntry& s);
      bool operator == (const ScannerTransEntry& s);

      int getFState();

   private:

      int  _state;
      char _c;
      int _fstate;
   };

   class Scanner {

   public:

      Scanner();
      Scanner(Token t);

      Token getToken();
      void addState(ScannerStateEntry s);
      void addTransition(ScannerTransEntry t);
      bool checkPattern(const Chain& pattern);

   private:

      Token _token;
      ListT<ScannerStateEntry> _stateList;
      ListT<ScannerTransEntry> _transList;
   };

   ListT<Scanner> _scannerList;
   class StackEntry {

   public:

      StackEntry();
      StackEntry(Symbol prod, int num, int state, Chain tval = "");
      StackEntry& operator = (const StackEntry& a);

      int getState();
      Symbol getSymbol();
      Chain& getTval();

   private:

      Symbol _symbol;
      int _num;
      int _state;
      Chain _tval;
   };

   class ActionEntry {

   public:

      ActionEntry();
      ActionEntry(Action action, int num);
      bool operator == (const ActionEntry& a);
      ActionEntry& operator = (const ActionEntry& a);

      Action getAction();
      int getNum();

   private:

      Action _action;
      int _num;
   };

   ActionEntry _actionMap[285][78];
   int _jumpMap[285][68];

   class ProdEntry {

   public:

      ProdEntry();
      ProdEntry(int id);
      ProdEntry(int id, Production prod, int numSymbol);
      bool operator == (const ProdEntry& a);
      ProdEntry& operator = (const ProdEntry& a);

      int getId();
      Production getProd();
      int getNumSymbol();

   private:

      int _id;
      Production _prod;
      int _numSymbol;

   };

   ListT<ProdEntry> _prodInfo;

   bool isSepIgnore(char c);
   bool isSepSign(char c);
   bool shiftToken();

   bool getAction(int state, Token token, Action& a, int& num);
   bool getJump(int state, Production prod, int& fstate);

   Token _reservedToken;
   bool _isReserved;
   Token _token;
   char _tokenVal[MAXTOKENVAL];
   ListT<Chain> _tokenList;

};
