//
// File: OracleParser.cc
// This code was produced by the dragon parser generator
//
#include "OracleParser.h"
#include <lfcbase/Exception.h>
#include <lfcbase/StackT.h>

OracleParser::ScannerStateEntry::ScannerStateEntry()
{
}

OracleParser::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

OracleParser::ScannerStateEntry& OracleParser::ScannerStateEntry::operator = (const OracleParser::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool OracleParser::ScannerStateEntry::operator == (const OracleParser::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

OracleParser::ScannerStateType OracleParser::ScannerStateEntry::getType()
{
   return _type;
}
int OracleParser::ScannerStateEntry::getState()
{
   return _state;
}


OracleParser::ScannerTransEntry::ScannerTransEntry()
{
}

OracleParser::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

OracleParser::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

OracleParser::ScannerTransEntry& OracleParser::ScannerTransEntry::operator = (const OracleParser::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool OracleParser::ScannerTransEntry::operator == (const OracleParser::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int OracleParser::ScannerTransEntry::getFState()
{
   return _fstate;
}


OracleParser::Scanner::Scanner()
{
}


OracleParser::Scanner::Scanner(Token t)
{
   _token = t;
}

OracleParser::Token OracleParser::Scanner::getToken()
{
   return _token;
}

void OracleParser::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void OracleParser::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool OracleParser::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
OracleParser::StackEntry::StackEntry()
{
   _symbol = NONE;
}

OracleParser::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

OracleParser::StackEntry& OracleParser::StackEntry::operator = (const OracleParser::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int OracleParser::StackEntry::getState()
{
   return _state;
}
OracleParser::Symbol OracleParser::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& OracleParser::StackEntry::getTval()
{
   return _tval;
}

OracleParser::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

OracleParser::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool OracleParser::ActionEntry::operator == (const OracleParser::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

OracleParser::ActionEntry& OracleParser::ActionEntry::operator = (const OracleParser::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

OracleParser::Action OracleParser::ActionEntry::getAction()
{
   return _action;
}

int OracleParser::ActionEntry::getNum()
{
   return _num;
}

OracleParser::ProdEntry::ProdEntry()
{
}

OracleParser::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

OracleParser::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool OracleParser::ProdEntry::operator == (const OracleParser::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

OracleParser::ProdEntry& OracleParser::ProdEntry::operator = (const OracleParser::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int OracleParser::ProdEntry::getId()
{
   return _id;
}

OracleParser::Production OracleParser::ProdEntry::getProd()
{
   return _prod;
}

int OracleParser::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void OracleParser::loadScanner()
{
   Scanner s0(BOOL);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(4 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s0.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s0);

   Scanner s1(CREATE);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(6 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s1.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s1.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s1.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s1);

   Scanner s2(DATETIME);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(8 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s2.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s2.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s2.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s2.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s2.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s2);

   Scanner s3(DECIMAL);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(7 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s3.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s3.addTransition(ScannerTransEntry(6 ,'l' ,7));
   _scannerList.Insert(s3);

   Scanner s4(DEFAULT);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(7 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s4.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s4);

   Scanner s5(DOUBLE);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(6 ,FINAL));
   s5.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s5.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s5.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s5.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s5.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s5.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s5);

   Scanner s6(DROP);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(4 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s6.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s6);

   Scanner s7(ENUM);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s7);

   Scanner s8(ENGINE);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s8);

   Scanner s9(EXISTS);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(6 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s9.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s9.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s9.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s9);

   Scanner s10(FALSEVAL);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(5 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s10.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s10);

   Scanner s11(FLOAT);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(5 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s11.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s11);

   Scanner s12(FOREIGN);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(7 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s12.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s12);

   Scanner s13(IF);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,FINAL));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s13.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s13);

   Scanner s14(INDEX);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s14);

   Scanner s15(INT);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s15);

   Scanner s16(INTO);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(4 ,FINAL));
   s16.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s16.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s16.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s16.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s16);

   Scanner s17(INSERT);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(6 ,FINAL));
   s17.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s17.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s17.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s17.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s17.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s17.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s17);

   Scanner s18(KEY);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addState(ScannerStateEntry(3 ,FINAL));
   s18.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s18.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s18.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s18);

   Scanner s19(LOCK);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(4 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s19.addTransition(ScannerTransEntry(3 ,'k' ,4));
   _scannerList.Insert(s19);

   Scanner s20(LONGBLOB);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(8 ,FINAL));
   s20.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s20.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s20.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s20.addTransition(ScannerTransEntry(3 ,'g' ,4));
   s20.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s20.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s20.addTransition(ScannerTransEntry(6 ,'o' ,7));
   s20.addTransition(ScannerTransEntry(7 ,'b' ,8));
   _scannerList.Insert(s20);

   Scanner s21(MEDIUMTEXT);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(10 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'m' ,0));
   s21.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s21.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s21.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s21.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s21.addTransition(ScannerTransEntry(7 ,'e' ,8));
   s21.addTransition(ScannerTransEntry(8 ,'x' ,9));
   s21.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s21);

   Scanner s22(NOT);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s22);

   Scanner s23(NULLTOKEN);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s23);

   Scanner s24(PRIMARY);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(7 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s24.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s24.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s24);

   Scanner s25(SET);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s25);

   Scanner s26(TABLE);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(5 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s26.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s26.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s26);

   Scanner s27(TABLES);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(6 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s27.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s27.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s27);

   Scanner s28(TEXT);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(4 ,FINAL));
   s28.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s28.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s28.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s28.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s28);

   Scanner s29(TIMESTAMP);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(9 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s29.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s29.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s29.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s29.addTransition(ScannerTransEntry(8 ,'p' ,9));
   _scannerList.Insert(s29);

   Scanner s30(UNLOCK);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(6 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s30.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s30.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s30.addTransition(ScannerTransEntry(5 ,'k' ,6));
   _scannerList.Insert(s30);

   Scanner s31(UNIQUE);
   s31.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(2 ,START));
   s31.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(6 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s31.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s31.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s31.addTransition(ScannerTransEntry(3 ,'q' ,4));
   s31.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s31.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s31);

   Scanner s32(UNSIGNED);
   s32.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(2 ,START));
   s32.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(8 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s32.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s32.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s32.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s32.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s32.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s32.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s32.addTransition(ScannerTransEntry(7 ,'d' ,8));
   _scannerList.Insert(s32);

   Scanner s33(VALUES);
   s33.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(2 ,START));
   s33.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(6 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s33.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s33.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s33.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s33.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s33.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s33);

   Scanner s34(VARCHAR);
   s34.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(2 ,START));
   s34.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(7 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s34.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s34.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s34.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s34.addTransition(ScannerTransEntry(4 ,'h' ,5));
   s34.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s34.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s34);

   Scanner s35(WRITE);
   s35.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(2 ,START));
   s35.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(5 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s35.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s35.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s35.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s35.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s35);

   Scanner s36(MINUS);
   s36.addState(ScannerStateEntry(0 ,START));
   s36.addState(ScannerStateEntry(1 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s36);

   Scanner s37(EQU);
   s37.addState(ScannerStateEntry(0 ,START));
   s37.addState(ScannerStateEntry(1 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s37);

   Scanner s38(KSEP);
   s38.addState(ScannerStateEntry(0 ,START));
   s38.addState(ScannerStateEntry(1 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s38);

   Scanner s39(LB);
   s39.addState(ScannerStateEntry(0 ,START));
   s39.addState(ScannerStateEntry(1 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s39);

   Scanner s40(RB);
   s40.addState(ScannerStateEntry(0 ,START));
   s40.addState(ScannerStateEntry(1 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s40);

   Scanner s41(SEMICOLON);
   s41.addState(ScannerStateEntry(0 ,START));
   s41.addState(ScannerStateEntry(1 ,FINAL));
   s41.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s41);

   Scanner s42(INTVAL);
   s42.addState(ScannerStateEntry(0 ,START));
   s42.addState(ScannerStateEntry(1 ,FINAL));
   s42.addState(ScannerStateEntry(2 ,FINAL));
   s42.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s42.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s42.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s42.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s42);

   Scanner s43(FLOATVAL);
   s43.addState(ScannerStateEntry(0 ,START));
   s43.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s43.addState(ScannerStateEntry(3 ,FINAL));
   s43.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s43.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s43.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s43.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s43.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s43.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s43);

   Scanner s44(QIDENTIFIER);
   s44.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s44.addState(ScannerStateEntry(2 ,START));
   s44.addState(ScannerStateEntry(3 ,FINAL));
   s44.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s44.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s44.addTransition(ScannerTransEntry(1 ,'`' ,3));
   s44.addTransition(ScannerTransEntry(2 ,'`' ,0));
   _scannerList.Insert(s44);

   Scanner s45(IDENTIFIER);
   s45.addState(ScannerStateEntry(0 ,START));
   s45.addState(ScannerStateEntry(1 ,FINAL));
   s45.addTransition(ScannerTransEntry(0 ,'@' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'@' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'z' ,1));
   _scannerList.Insert(s45);

}
void OracleParser::loadParser0()
{
   _actionMap[107][UNSIGNED] = ActionEntry(REDUCE, 49);
   _actionMap[107][NULLTOKEN] = ActionEntry(REDUCE, 49);
   _actionMap[107][NOT] = ActionEntry(REDUCE, 49);
   _actionMap[107][DEFAULT] = ActionEntry(REDUCE, 49);
   _actionMap[107][RB] = ActionEntry(REDUCE, 49);
   _actionMap[107][KSEP] = ActionEntry(REDUCE, 49);
   _actionMap[103][KSEP] = ActionEntry(REDUCE, 23);
   _actionMap[103][RB] = ActionEntry(REDUCE, 23);
   _actionMap[104][KSEP] = ActionEntry(REDUCE, 21);
   _actionMap[104][RB] = ActionEntry(REDUCE, 21);
   _actionMap[105][RB] = ActionEntry(SHIFT, 107);
   _actionMap[106][KSEP] = ActionEntry(REDUCE, 42);
   _actionMap[106][RB] = ActionEntry(REDUCE, 42);
   _actionMap[93][QIDENTIFIER] = ActionEntry(SHIFT, 103);
   _actionMap[94][KSEP] = ActionEntry(REDUCE, 22);
   _actionMap[94][RB] = ActionEntry(REDUCE, 22);
   _actionMap[95][KSEP] = ActionEntry(REDUCE, 20);
   _actionMap[95][RB] = ActionEntry(REDUCE, 20);
   _actionMap[96][RB] = ActionEntry(SHIFT, 104);
   _actionMap[96][KSEP] = ActionEntry(SHIFT, 93);
   _actionMap[97][KSEP] = ActionEntry(REDUCE, 17);
   _actionMap[97][RB] = ActionEntry(REDUCE, 17);
   _actionMap[98][INTVAL] = ActionEntry(SHIFT, 105);
   _actionMap[99][INTVAL] = ActionEntry(SHIFT, 36);
   _actionMap[99][MINUS] = ActionEntry(SHIFT, 35);
   _actionMap[99][STRINGVAL] = ActionEntry(SHIFT, 33);
   _actionMap[99][NULLTOKEN] = ActionEntry(SHIFT, 34);
   _jumpMap[99][Constant] = 106;
   _actionMap[100][NULLTOKEN] = ActionEntry(REDUCE, 41);
   _actionMap[100][NOT] = ActionEntry(REDUCE, 41);
   _actionMap[100][DEFAULT] = ActionEntry(REDUCE, 41);
   _actionMap[100][RB] = ActionEntry(REDUCE, 41);
   _actionMap[100][KSEP] = ActionEntry(REDUCE, 41);
   _actionMap[101][UNSIGNED] = ActionEntry(REDUCE, 48);
   _actionMap[101][NULLTOKEN] = ActionEntry(REDUCE, 48);
   _actionMap[101][NOT] = ActionEntry(REDUCE, 48);
   _actionMap[101][DEFAULT] = ActionEntry(REDUCE, 48);
   _actionMap[101][RB] = ActionEntry(REDUCE, 48);
   _actionMap[101][KSEP] = ActionEntry(REDUCE, 48);
   _actionMap[102][NULLTOKEN] = ActionEntry(REDUCE, 35);
   _actionMap[102][NOT] = ActionEntry(REDUCE, 35);
   _actionMap[102][DEFAULT] = ActionEntry(REDUCE, 35);
   _actionMap[102][RB] = ActionEntry(REDUCE, 35);
   _actionMap[102][KSEP] = ActionEntry(REDUCE, 35);
   _actionMap[77][RB] = ActionEntry(SHIFT, 94);
   _actionMap[77][KSEP] = ActionEntry(SHIFT, 93);
   _actionMap[78][KSEP] = ActionEntry(REDUCE, 24);
   _actionMap[78][RB] = ActionEntry(REDUCE, 24);
   _actionMap[79][RB] = ActionEntry(SHIFT, 95);
   _actionMap[79][KSEP] = ActionEntry(SHIFT, 93);
}
void OracleParser::loadParser1()
{
   _actionMap[80][QIDENTIFIER] = ActionEntry(SHIFT, 78);
   _jumpMap[80][KeyList] = 96;
   _actionMap[81][KSEP] = ActionEntry(REDUCE, 12);
   _actionMap[81][RB] = ActionEntry(REDUCE, 12);
   _actionMap[82][KSEP] = ActionEntry(REDUCE, 18);
   _actionMap[82][RB] = ActionEntry(REDUCE, 18);
   _actionMap[83][INTVAL] = ActionEntry(SHIFT, 36);
   _actionMap[83][MINUS] = ActionEntry(SHIFT, 35);
   _actionMap[83][STRINGVAL] = ActionEntry(SHIFT, 33);
   _actionMap[83][NULLTOKEN] = ActionEntry(SHIFT, 34);
   _jumpMap[83][Constant] = 97;
   _actionMap[84][DEFAULT] = ActionEntry(REDUCE, 14);
   _actionMap[84][RB] = ActionEntry(REDUCE, 14);
   _actionMap[84][KSEP] = ActionEntry(REDUCE, 14);
   _actionMap[85][NULLTOKEN] = ActionEntry(REDUCE, 34);
   _actionMap[85][NOT] = ActionEntry(REDUCE, 34);
   _actionMap[85][DEFAULT] = ActionEntry(REDUCE, 34);
   _actionMap[85][RB] = ActionEntry(REDUCE, 34);
   _actionMap[85][KSEP] = ActionEntry(REDUCE, 34);
   _actionMap[86][NULLTOKEN] = ActionEntry(REDUCE, 50);
   _actionMap[86][NOT] = ActionEntry(REDUCE, 50);
   _actionMap[86][DEFAULT] = ActionEntry(REDUCE, 50);
   _actionMap[86][RB] = ActionEntry(REDUCE, 50);
   _actionMap[86][KSEP] = ActionEntry(REDUCE, 50);
   _actionMap[87][KSEP] = ActionEntry(SHIFT, 98);
   _actionMap[88][RB] = ActionEntry(SHIFT, 100);
   _actionMap[88][KSEP] = ActionEntry(SHIFT, 99);
   _actionMap[89][KSEP] = ActionEntry(REDUCE, 43);
   _actionMap[89][RB] = ActionEntry(REDUCE, 43);
   _actionMap[90][NULLTOKEN] = ActionEntry(REDUCE, 33);
   _actionMap[90][NOT] = ActionEntry(REDUCE, 33);
   _actionMap[90][DEFAULT] = ActionEntry(REDUCE, 33);
   _actionMap[90][RB] = ActionEntry(REDUCE, 33);
   _actionMap[90][KSEP] = ActionEntry(REDUCE, 33);
   _actionMap[91][RB] = ActionEntry(SHIFT, 101);
   _actionMap[92][RB] = ActionEntry(SHIFT, 102);
   _actionMap[62][KSEP] = ActionEntry(REDUCE, 29);
   _actionMap[62][RB] = ActionEntry(REDUCE, 29);
   _actionMap[63][KSEP] = ActionEntry(REDUCE, 10);
   _actionMap[63][RB] = ActionEntry(REDUCE, 10);
   _actionMap[64][QIDENTIFIER] = ActionEntry(SHIFT, 78);
   _jumpMap[64][KeyList] = 77;
   _actionMap[65][QIDENTIFIER] = ActionEntry(SHIFT, 78);
   _jumpMap[65][KeyList] = 79;
   _actionMap[66][LB] = ActionEntry(SHIFT, 80);
   _actionMap[67][KSEP] = ActionEntry(REDUCE, 19);
   _actionMap[67][DEFAULT] = ActionEntry(SHIFT, 83);
   _actionMap[67][RB] = ActionEntry(REDUCE, 19);
   _jumpMap[67][DefaultDefOpt] = 82;
   _jumpMap[67][DefaultOpt] = 81;
}
void OracleParser::loadParser2()
{
   _actionMap[68][DEFAULT] = ActionEntry(REDUCE, 15);
   _actionMap[68][RB] = ActionEntry(REDUCE, 15);
   _actionMap[68][KSEP] = ActionEntry(REDUCE, 15);
   _actionMap[69][NULLTOKEN] = ActionEntry(SHIFT, 84);
   _actionMap[70][DEFAULT] = ActionEntry(REDUCE, 13);
   _actionMap[70][RB] = ActionEntry(REDUCE, 13);
   _actionMap[70][KSEP] = ActionEntry(REDUCE, 13);
   _actionMap[71][UNSIGNED] = ActionEntry(SHIFT, 86);
   _actionMap[71][NULLTOKEN] = ActionEntry(REDUCE, 51);
   _actionMap[71][NOT] = ActionEntry(REDUCE, 51);
   _actionMap[71][DEFAULT] = ActionEntry(REDUCE, 51);
   _actionMap[71][RB] = ActionEntry(REDUCE, 51);
   _actionMap[71][KSEP] = ActionEntry(REDUCE, 51);
   _jumpMap[71][UnsignedOpt] = 85;
   _actionMap[72][INTVAL] = ActionEntry(SHIFT, 87);
   _actionMap[73][INTVAL] = ActionEntry(SHIFT, 36);
   _actionMap[73][MINUS] = ActionEntry(SHIFT, 35);
   _actionMap[73][STRINGVAL] = ActionEntry(SHIFT, 33);
   _actionMap[73][NULLTOKEN] = ActionEntry(SHIFT, 34);
   _jumpMap[73][Constant] = 89;
   _jumpMap[73][ConstList] = 88;
   _actionMap[74][UNSIGNED] = ActionEntry(SHIFT, 86);
   _actionMap[74][NULLTOKEN] = ActionEntry(REDUCE, 51);
   _actionMap[74][NOT] = ActionEntry(REDUCE, 51);
   _actionMap[74][DEFAULT] = ActionEntry(REDUCE, 51);
   _actionMap[74][RB] = ActionEntry(REDUCE, 51);
   _actionMap[74][KSEP] = ActionEntry(REDUCE, 51);
   _jumpMap[74][UnsignedOpt] = 90;
   _actionMap[75][INTVAL] = ActionEntry(SHIFT, 91);
   _actionMap[76][INTVAL] = ActionEntry(SHIFT, 92);
   _actionMap[43][SEMICOLON] = ActionEntry(REDUCE, 26);
   _actionMap[43][KSEP] = ActionEntry(REDUCE, 26);
   _actionMap[44][INTVAL] = ActionEntry(SHIFT, 36);
   _actionMap[44][MINUS] = ActionEntry(SHIFT, 35);
   _actionMap[44][STRINGVAL] = ActionEntry(SHIFT, 33);
   _actionMap[44][NULLTOKEN] = ActionEntry(SHIFT, 34);
   _jumpMap[44][Constant] = 62;
   _actionMap[45][SEMICOLON] = ActionEntry(REDUCE, 28);
   _actionMap[45][KSEP] = ActionEntry(REDUCE, 28);
   _actionMap[46][KSEP] = ActionEntry(REDUCE, 45);
   _actionMap[46][RB] = ActionEntry(REDUCE, 45);
   _actionMap[47][QIDENTIFIER] = ActionEntry(SHIFT, 42);
   _actionMap[47][PRIMARY] = ActionEntry(SHIFT, 40);
   _actionMap[47][UNIQUE] = ActionEntry(SHIFT, 41);
   _actionMap[47][KEY] = ActionEntry(SHIFT, 39);
   _jumpMap[47][ColumnDesc] = 63;
   _actionMap[48][SEMICOLON] = ActionEntry(REDUCE, 6);
   _actionMap[49][LB] = ActionEntry(SHIFT, 64);
   _actionMap[50][LB] = ActionEntry(SHIFT, 65);
   _actionMap[51][QIDENTIFIER] = ActionEntry(SHIFT, 66);
}
void OracleParser::loadParser3()
{
   _actionMap[52][KSEP] = ActionEntry(REDUCE, 16);
   _actionMap[52][RB] = ActionEntry(REDUCE, 16);
   _actionMap[52][DEFAULT] = ActionEntry(REDUCE, 16);
   _actionMap[52][NULLTOKEN] = ActionEntry(SHIFT, 70);
   _actionMap[52][NOT] = ActionEntry(SHIFT, 69);
   _jumpMap[52][DefaultNullOpt] = 68;
   _jumpMap[52][NullOpt] = 67;
   _actionMap[53][NULLTOKEN] = ActionEntry(REDUCE, 37);
   _actionMap[53][NOT] = ActionEntry(REDUCE, 37);
   _actionMap[53][DEFAULT] = ActionEntry(REDUCE, 37);
   _actionMap[53][RB] = ActionEntry(REDUCE, 37);
   _actionMap[53][KSEP] = ActionEntry(REDUCE, 37);
   _actionMap[54][LB] = ActionEntry(SHIFT, 72);
   _jumpMap[54][DecimalDimOpt] = 71;
   _actionMap[55][LB] = ActionEntry(SHIFT, 73);
   _actionMap[56][LB] = ActionEntry(SHIFT, 75);
   _jumpMap[56][DimOpt] = 74;
   _actionMap[57][NULLTOKEN] = ActionEntry(REDUCE, 38);
   _actionMap[57][NOT] = ActionEntry(REDUCE, 38);
   _actionMap[57][DEFAULT] = ActionEntry(REDUCE, 38);
   _actionMap[57][RB] = ActionEntry(REDUCE, 38);
   _actionMap[57][KSEP] = ActionEntry(REDUCE, 38);
   _actionMap[58][NULLTOKEN] = ActionEntry(REDUCE, 39);
   _actionMap[58][NOT] = ActionEntry(REDUCE, 39);
   _actionMap[58][DEFAULT] = ActionEntry(REDUCE, 39);
   _actionMap[58][RB] = ActionEntry(REDUCE, 39);
   _actionMap[58][KSEP] = ActionEntry(REDUCE, 39);
   _actionMap[59][NULLTOKEN] = ActionEntry(REDUCE, 40);
   _actionMap[59][NOT] = ActionEntry(REDUCE, 40);
   _actionMap[59][DEFAULT] = ActionEntry(REDUCE, 40);
   _actionMap[59][RB] = ActionEntry(REDUCE, 40);
   _actionMap[59][KSEP] = ActionEntry(REDUCE, 40);
   _actionMap[60][NULLTOKEN] = ActionEntry(REDUCE, 36);
   _actionMap[60][NOT] = ActionEntry(REDUCE, 36);
   _actionMap[60][DEFAULT] = ActionEntry(REDUCE, 36);
   _actionMap[60][RB] = ActionEntry(REDUCE, 36);
   _actionMap[60][KSEP] = ActionEntry(REDUCE, 36);
   _actionMap[61][LB] = ActionEntry(SHIFT, 76);
   _actionMap[30][LB] = ActionEntry(SHIFT, 26);
   _jumpMap[30][InsertValueSpec] = 43;
   _actionMap[31][RB] = ActionEntry(SHIFT, 45);
   _actionMap[31][KSEP] = ActionEntry(SHIFT, 44);
   _actionMap[32][KSEP] = ActionEntry(REDUCE, 30);
   _actionMap[32][RB] = ActionEntry(REDUCE, 30);
   _actionMap[33][KSEP] = ActionEntry(REDUCE, 46);
   _actionMap[33][RB] = ActionEntry(REDUCE, 46);
   _actionMap[34][KSEP] = ActionEntry(REDUCE, 47);
   _actionMap[34][RB] = ActionEntry(REDUCE, 47);
   _actionMap[35][INTVAL] = ActionEntry(SHIFT, 46);
   _actionMap[36][KSEP] = ActionEntry(REDUCE, 44);
}
void OracleParser::loadParser4()
{
   _actionMap[36][RB] = ActionEntry(REDUCE, 44);
   _actionMap[37][RB] = ActionEntry(SHIFT, 48);
   _actionMap[37][KSEP] = ActionEntry(SHIFT, 47);
   _actionMap[38][KSEP] = ActionEntry(REDUCE, 11);
   _actionMap[38][RB] = ActionEntry(REDUCE, 11);
   _actionMap[39][QIDENTIFIER] = ActionEntry(SHIFT, 49);
   _actionMap[40][KEY] = ActionEntry(SHIFT, 50);
   _actionMap[41][KEY] = ActionEntry(SHIFT, 51);
   _actionMap[42][INT] = ActionEntry(SHIFT, 56);
   _actionMap[42][DECIMAL] = ActionEntry(SHIFT, 54);
   _actionMap[42][VARCHAR] = ActionEntry(SHIFT, 61);
   _actionMap[42][TIMESTAMP] = ActionEntry(SHIFT, 60);
   _actionMap[42][DATETIME] = ActionEntry(SHIFT, 53);
   _actionMap[42][LONGBLOB] = ActionEntry(SHIFT, 57);
   _actionMap[42][MEDIUMTEXT] = ActionEntry(SHIFT, 58);
   _actionMap[42][TEXT] = ActionEntry(SHIFT, 59);
   _actionMap[42][ENUM] = ActionEntry(SHIFT, 55);
   _jumpMap[42][DataTypeProd] = 52;
   _actionMap[24][KSEP] = ActionEntry(SHIFT, 30);
   _actionMap[24][SEMICOLON] = ActionEntry(REDUCE, 25);
   _actionMap[25][SEMICOLON] = ActionEntry(REDUCE, 27);
   _actionMap[25][KSEP] = ActionEntry(REDUCE, 27);
   _actionMap[26][INTVAL] = ActionEntry(SHIFT, 36);
   _actionMap[26][MINUS] = ActionEntry(SHIFT, 35);
   _actionMap[26][STRINGVAL] = ActionEntry(SHIFT, 33);
   _actionMap[26][NULLTOKEN] = ActionEntry(SHIFT, 34);
   _jumpMap[26][Constant] = 32;
   _jumpMap[26][InsertValueList] = 31;
   _actionMap[27][QIDENTIFIER] = ActionEntry(SHIFT, 42);
   _actionMap[27][PRIMARY] = ActionEntry(SHIFT, 40);
   _actionMap[27][UNIQUE] = ActionEntry(SHIFT, 41);
   _actionMap[27][KEY] = ActionEntry(SHIFT, 39);
   _jumpMap[27][ColumnDesc] = 38;
   _jumpMap[27][ColumnList] = 37;
   _actionMap[28][QIDENTIFIER] = ActionEntry(REDUCE, 9);
   _actionMap[29][SEMICOLON] = ActionEntry(REDUCE, 4);
   _actionMap[19][SEMICOLON] = ActionEntry(REDUCE, 1);
   _actionMap[19][SET] = ActionEntry(REDUCE, 1);
   _actionMap[19][CREATE] = ActionEntry(REDUCE, 1);
   _actionMap[19][DROP] = ActionEntry(REDUCE, 1);
   _actionMap[19][INSERT] = ActionEntry(REDUCE, 1);
   _actionMap[19][ENDTOKEN] = ActionEntry(REDUCE, 1);
   _actionMap[20][LB] = ActionEntry(SHIFT, 26);
   _jumpMap[20][InsertValueSpec] = 25;
   _jumpMap[20][InsertValueSpecList] = 24;
   _actionMap[21][LB] = ActionEntry(SHIFT, 27);
   _actionMap[22][EXISTS] = ActionEntry(SHIFT, 28);
   _actionMap[23][IDENTIFIER] = ActionEntry(SHIFT, 29);
   _actionMap[10][SEMICOLON] = ActionEntry(SHIFT, 19);
   _actionMap[11][SEMICOLON] = ActionEntry(REDUCE, 2);
}
void OracleParser::loadParser5()
{
   _actionMap[11][SET] = ActionEntry(REDUCE, 2);
   _actionMap[11][CREATE] = ActionEntry(REDUCE, 2);
   _actionMap[11][DROP] = ActionEntry(REDUCE, 2);
   _actionMap[11][INSERT] = ActionEntry(REDUCE, 2);
   _actionMap[11][ENDTOKEN] = ActionEntry(REDUCE, 2);
   _actionMap[12][SEMICOLON] = ActionEntry(REDUCE, 7);
   _actionMap[13][VALUES] = ActionEntry(REDUCE, 32);
   _actionMap[13][SEMICOLON] = ActionEntry(REDUCE, 32);
   _actionMap[13][LB] = ActionEntry(REDUCE, 32);
   _actionMap[14][VALUES] = ActionEntry(SHIFT, 20);
   _actionMap[15][QIDENTIFIER] = ActionEntry(SHIFT, 13);
   _jumpMap[15][Table] = 21;
   _actionMap[16][IF] = ActionEntry(SHIFT, 22);
   _actionMap[16][QIDENTIFIER] = ActionEntry(REDUCE, 8);
   _actionMap[17][QIDENTIFIER] = ActionEntry(REDUCE, 31);
   _actionMap[18][EQU] = ActionEntry(SHIFT, 23);
   _actionMap[1][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[1][INSERT] = ActionEntry(SHIFT, 8);
   _actionMap[1][DROP] = ActionEntry(SHIFT, 7);
   _actionMap[1][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[1][SET] = ActionEntry(SHIFT, 9);
   _actionMap[1][CREATE] = ActionEntry(SHIFT, 6);
   _jumpMap[1][InsertPrefix] = 5;
   _jumpMap[1][InsertStatement] = 4;
   _jumpMap[1][DropOpt] = 3;
   _jumpMap[1][Statement] = 10;
   _actionMap[2][SEMICOLON] = ActionEntry(SHIFT, 11);
   _actionMap[3][QIDENTIFIER] = ActionEntry(SHIFT, 13);
   _jumpMap[3][Table] = 12;
   _actionMap[4][SEMICOLON] = ActionEntry(REDUCE, 5);
   _actionMap[5][QIDENTIFIER] = ActionEntry(SHIFT, 13);
   _jumpMap[5][Table] = 14;
   _actionMap[6][TABLE] = ActionEntry(SHIFT, 15);
   _actionMap[7][TABLE] = ActionEntry(SHIFT, 16);
   _actionMap[8][INTO] = ActionEntry(SHIFT, 17);
   _actionMap[9][IDENTIFIER] = ActionEntry(SHIFT, 18);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 8);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 7);
   _actionMap[0][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[0][SET] = ActionEntry(SHIFT, 9);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 6);
   _jumpMap[0][InsertPrefix] = 5;
   _jumpMap[0][InsertStatement] = 4;
   _jumpMap[0][DropOpt] = 3;
   _jumpMap[0][Statement] = 2;
   _jumpMap[0][StatementList] = 1;
}
void OracleParser::loadParser6()
{
   _prodInfo.Insert(ProdEntry(51, UnsignedOpt, 0));
   _prodInfo.Insert(ProdEntry(50, UnsignedOpt, 1));
   _prodInfo.Insert(ProdEntry(49, DecimalDimOpt, 5));
   _prodInfo.Insert(ProdEntry(48, DimOpt, 3));
   _prodInfo.Insert(ProdEntry(47, Constant, 1));
   _prodInfo.Insert(ProdEntry(46, Constant, 1));
   _prodInfo.Insert(ProdEntry(45, Constant, 2));
   _prodInfo.Insert(ProdEntry(44, Constant, 1));
   _prodInfo.Insert(ProdEntry(43, ConstList, 1));
   _prodInfo.Insert(ProdEntry(42, ConstList, 3));
   _prodInfo.Insert(ProdEntry(41, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(40, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(39, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(38, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(37, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(36, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(35, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(34, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(33, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(32, Table, 1));
   _prodInfo.Insert(ProdEntry(31, InsertPrefix, 2));
   _prodInfo.Insert(ProdEntry(30, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(29, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(28, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(27, InsertValueSpecList, 1));
   _prodInfo.Insert(ProdEntry(26, InsertValueSpecList, 3));
   _prodInfo.Insert(ProdEntry(25, InsertStatement, 4));
   _prodInfo.Insert(ProdEntry(24, KeyList, 1));
   _prodInfo.Insert(ProdEntry(23, KeyList, 3));
   _prodInfo.Insert(ProdEntry(22, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(21, ColumnDesc, 6));
   _prodInfo.Insert(ProdEntry(20, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(19, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(18, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(17, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(16, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(15, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(14, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(13, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(12, ColumnDesc, 4));
   _prodInfo.Insert(ProdEntry(11, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(10, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(9, DropOpt, 4));
   _prodInfo.Insert(ProdEntry(8, DropOpt, 2));
   _prodInfo.Insert(ProdEntry(7, Statement, 2));
   _prodInfo.Insert(ProdEntry(6, Statement, 6));
   _prodInfo.Insert(ProdEntry(5, Statement, 1));
   _prodInfo.Insert(ProdEntry(4, Statement, 4));
   _prodInfo.Insert(ProdEntry(3, Statement, 0));
   _prodInfo.Insert(ProdEntry(2, StatementList, 2));
   _prodInfo.Insert(ProdEntry(1, StatementList, 3));
   _prodInfo.Insert(ProdEntry(0, Start, 1));
}

OracleParser::OracleParser()
{
   loadScanner();
   for ( int i=0; i < 108; i++)
   {
      int j;
      for ( j = 0; j < 48; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 24; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   _isReserved = false;
}

OracleParser::~OracleParser()
{
}

void OracleParser::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 50:
                     storeUnsignedType();
                     break;
                  case 49:
                     storeDecimalDim();
                     break;
                  case 48:
                     storeDim();
                     break;
                  case 47:
                     storeNullValue();
                     break;
                  case 46:
                     storeVarcharValue();
                     break;
                  case 45:
                     storeNegIntValue();
                     break;
                  case 44:
                     storeIntValue();
                     break;
                  case 41:
                     storeEnumType();
                     break;
                  case 40:
                     storeMediumTextType();
                     break;
                  case 39:
                     storeMediumTextType();
                     break;
                  case 37:
                     storeDatetimeType();
                     break;
                  case 36:
                     storeTimestampType();
                     break;
                  case 35:
                     storeVarcharType();
                     break;
                  case 34:
                     storeDecimalType();
                     break;
                  case 33:
                     storeIntType();
                     break;
                  case 32:
                     storeTable();
                     break;
                  case 31:
                     insertPreAction();
                     break;
                  case 30:
                     insertConstValue();
                     break;
                  case 29:
                     insertConstValue();
                     break;
                  case 28:
                     execInsert();
                     break;
                  case 25:
                     insertPostAction();
                     break;
                  case 24:
                     storeKeyColumn();
                     break;
                  case 23:
                     storeKeyColumn();
                     break;
                  case 22:
                     storeKey();
                     break;
                  case 21:
                     storeUniqueKey();
                     break;
                  case 20:
                     storePrimaryKey();
                     break;
                  case 18:
                     storeDefaultNullOpt();
                     break;
                  case 17:
                     storeDefaultOpt();
                     break;
                  case 15:
                     storeNullOpt();
                     break;
                  case 14:
                     storeNotNullOpt();
                     break;
                  case 13:
                     storeNullOpt();
                     break;
                  case 12:
                     storeAttrColumn();
                     break;
                  case 9:
                     dropOpt2();
                     break;
                  case 8:
                     dropOpt1();
                     break;
                  case 7:
                     execDrop();
                     break;
                  case 6:
                     execCreate();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               postAction();
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool OracleParser::getAction(int state, OracleParser::Token token, OracleParser::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool OracleParser::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool OracleParser::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   return false;
}
bool OracleParser::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   if (c == '\r') return true;
   return false;
}
bool OracleParser::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void OracleParser::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
