//
// File: OracleParser.h
// This code was produced by the dragon parser generator
//
#include <lfcbase/Exception.h>
#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>
#define MAXTOKENVAL 100

class OracleParser
{

public:

   OracleParser();
   ~OracleParser();

   void parse();
   ListT<Chain>& getTokenList() { return _tokenList; }

protected:

   virtual char nextChar() = 0;
   virtual void backChar() = 0;
   virtual void postAction() = 0;
   virtual void execCreate() = 0;
   virtual void execDrop() = 0;
   virtual void dropOpt1() = 0;
   virtual void dropOpt2() = 0;
   virtual void storeAttrColumn() = 0;
   virtual void storeNotNullOpt() = 0;
   virtual void storeNullOpt() = 0;
   virtual void storeDefaultOpt() = 0;
   virtual void storeDefaultNullOpt() = 0;
   virtual void storePrimaryKey() = 0;
   virtual void storeUniqueKey() = 0;
   virtual void storeKey() = 0;
   virtual void storeKeyColumn() = 0;
   virtual void insertPostAction() = 0;
   virtual void execInsert() = 0;
   virtual void insertConstValue() = 0;
   virtual void insertPreAction() = 0;
   virtual void storeTable() = 0;
   virtual void storeIntType() = 0;
   virtual void storeDecimalType() = 0;
   virtual void storeVarcharType() = 0;
   virtual void storeTimestampType() = 0;
   virtual void storeDatetimeType() = 0;
   virtual void storeMediumTextType() = 0;
   virtual void storeEnumType() = 0;
   virtual void storeIntValue() = 0;
   virtual void storeNegIntValue() = 0;
   virtual void storeVarcharValue() = 0;
   virtual void storeNullValue() = 0;
   virtual void storeDim() = 0;
   virtual void storeDecimalDim() = 0;
   virtual void storeUnsignedType() = 0;

   enum Token {
      IDENTIFIER,
      QIDENTIFIER,
      FLOATVAL,
      INTVAL,
      SEMICOLON,
      RB,
      LB,
      KSEP,
      EQU,
      MINUS,
      WRITE,
      VARCHAR,
      VALUES,
      UNSIGNED,
      UNIQUE,
      UNLOCK,
      TIMESTAMP,
      TEXT,
      TABLES,
      TABLE,
      SET,
      PRIMARY,
      NULLTOKEN,
      NOT,
      MEDIUMTEXT,
      LONGBLOB,
      LOCK,
      KEY,
      INSERT,
      INTO,
      INT,
      INDEX,
      IF,
      FOREIGN,
      FLOAT,
      FALSEVAL,
      EXISTS,
      ENGINE,
      ENUM,
      DROP,
      DOUBLE,
      DEFAULT,
      DECIMAL,
      DATETIME,
      CREATE,
      BOOL,
      STRINGVAL,
      ENDTOKEN
   };
   void setReserved(Token t);

private:

   enum Symbol { PROD, TOKEN, NONE };
   enum ScannerStateType { START, INTERMEDIATE, FINAL, ANY };
   enum Action { SHIFT, REDUCE, ACCEPT, NULLACTION };
   enum Production {
      Start,
      StatementList,
      Statement,
      DropOpt,
      ColumnList,
      NullOpt,
      DefaultNullOpt,
      DefaultOpt,
      DefaultDefOpt,
      ColumnDesc,
      KeyList,
      InsertStatement,
      InsertValueSpecList,
      InsertValueSpec,
      InsertValueList,
      InsertPrefix,
      Table,
      DataTypeProd,
      ConstList,
      Constant,
      DimOpt,
      DecimalDimOpt,
      UnsignedOpt
   };
   void loadScanner();
   void loadParser0();
   void loadParser1();
   void loadParser2();
   void loadParser3();
   void loadParser4();
   void loadParser5();
   void loadParser6();

   class ScannerStateEntry {

   public:

      ScannerStateEntry();
      ScannerStateEntry(int state, ScannerStateType type = INTERMEDIATE);
      ScannerStateEntry& operator = (const ScannerStateEntry& s);
      bool operator == (const ScannerStateEntry& s);

	   int getState();
      ScannerStateType getType();

   private:

      int _state;
      ScannerStateType _type;
   };

class ScannerTransEntry {

   public:

      ScannerTransEntry();
      ScannerTransEntry(int state, char c);
      ScannerTransEntry(int state, char c, int fstate);
      ScannerTransEntry& operator = (const ScannerTransEntry& s);
      bool operator == (const ScannerTransEntry& s);

      int getFState();

   private:

      int  _state;
      char _c;
      int _fstate;
   };

   class Scanner {

   public:

      Scanner();
      Scanner(Token t);

      Token getToken();
      void addState(ScannerStateEntry s);
      void addTransition(ScannerTransEntry t);
      bool checkPattern(const Chain& pattern);

   private:

      Token _token;
      ListT<ScannerStateEntry> _stateList;
      ListT<ScannerTransEntry> _transList;
   };

   ListT<Scanner> _scannerList;
   class StackEntry {

   public:

      StackEntry();
      StackEntry(Symbol prod, int num, int state, Chain tval = "");
      StackEntry& operator = (const StackEntry& a);

      int getState();
      Symbol getSymbol();
      Chain& getTval();

   private:

      Symbol _symbol;
      int _num;
      int _state;
      Chain _tval;
   };

   class ActionEntry {

   public:

      ActionEntry();
      ActionEntry(Action action, int num);
      bool operator == (const ActionEntry& a);
      ActionEntry& operator = (const ActionEntry& a);

      Action getAction();
      int getNum();

   private:

      Action _action;
      int _num;
   };

   ActionEntry _actionMap[108][48];
   int _jumpMap[108][24];

   class ProdEntry {

   public:

      ProdEntry();
      ProdEntry(int id);
      ProdEntry(int id, Production prod, int numSymbol);
      bool operator == (const ProdEntry& a);
      ProdEntry& operator = (const ProdEntry& a);

      int getId();
      Production getProd();
      int getNumSymbol();

   private:

      int _id;
      Production _prod;
      int _numSymbol;

   };

   ListT<ProdEntry> _prodInfo;

   bool isSepIgnore(char c);
   bool isSepSign(char c);
   bool shiftToken();

   bool getAction(int state, Token token, Action& a, int& num);
   bool getJump(int state, Production prod, int& fstate);

   Token _reservedToken;
   bool _isReserved;
   Token _token;
   char _tokenVal[MAXTOKENVAL];
   ListT<Chain> _tokenList;

};
