//
// File: PostgresParser.cc
// This code was produced by the dragon parser generator
//
#include "PostgresParser.h"
#include <lfcbase/Exception.h>
#include <lfcbase/StackT.h>

PostgresParser::ScannerStateEntry::ScannerStateEntry()
{
}

PostgresParser::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

PostgresParser::ScannerStateEntry& PostgresParser::ScannerStateEntry::operator = (const PostgresParser::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool PostgresParser::ScannerStateEntry::operator == (const PostgresParser::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

PostgresParser::ScannerStateType PostgresParser::ScannerStateEntry::getType()
{
   return _type;
}
int PostgresParser::ScannerStateEntry::getState()
{
   return _state;
}


PostgresParser::ScannerTransEntry::ScannerTransEntry()
{
}

PostgresParser::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

PostgresParser::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

PostgresParser::ScannerTransEntry& PostgresParser::ScannerTransEntry::operator = (const PostgresParser::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool PostgresParser::ScannerTransEntry::operator == (const PostgresParser::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int PostgresParser::ScannerTransEntry::getFState()
{
   return _fstate;
}


PostgresParser::Scanner::Scanner()
{
}


PostgresParser::Scanner::Scanner(Token t)
{
   _token = t;
}

PostgresParser::Token PostgresParser::Scanner::getToken()
{
   return _token;
}

void PostgresParser::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void PostgresParser::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool PostgresParser::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
PostgresParser::StackEntry::StackEntry()
{
   _symbol = NONE;
}

PostgresParser::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

PostgresParser::StackEntry& PostgresParser::StackEntry::operator = (const PostgresParser::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int PostgresParser::StackEntry::getState()
{
   return _state;
}
PostgresParser::Symbol PostgresParser::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& PostgresParser::StackEntry::getTval()
{
   return _tval;
}

PostgresParser::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

PostgresParser::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool PostgresParser::ActionEntry::operator == (const PostgresParser::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

PostgresParser::ActionEntry& PostgresParser::ActionEntry::operator = (const PostgresParser::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

PostgresParser::Action PostgresParser::ActionEntry::getAction()
{
   return _action;
}

int PostgresParser::ActionEntry::getNum()
{
   return _num;
}

PostgresParser::ProdEntry::ProdEntry()
{
}

PostgresParser::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

PostgresParser::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool PostgresParser::ProdEntry::operator == (const PostgresParser::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

PostgresParser::ProdEntry& PostgresParser::ProdEntry::operator = (const PostgresParser::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int PostgresParser::ProdEntry::getId()
{
   return _id;
}

PostgresParser::Production PostgresParser::ProdEntry::getProd()
{
   return _prod;
}

int PostgresParser::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void PostgresParser::loadScanner()
{
   Scanner s0(AUTOINCREMENT);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(11 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(12 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(13 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(14 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s0.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s0.addTransition(ScannerTransEntry(4 ,'_' ,5));
   s0.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s0.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s0.addTransition(ScannerTransEntry(7 ,'c' ,8));
   s0.addTransition(ScannerTransEntry(8 ,'r' ,9));
   s0.addTransition(ScannerTransEntry(9 ,'e' ,10));
   s0.addTransition(ScannerTransEntry(10 ,'m' ,11));
   s0.addTransition(ScannerTransEntry(11 ,'e' ,12));
   s0.addTransition(ScannerTransEntry(12 ,'n' ,13));
   s0.addTransition(ScannerTransEntry(13 ,'t' ,14));
   _scannerList.Insert(s0);

   Scanner s1(BOOL);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(4 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s1.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s1);

   Scanner s2(CHARSET);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(7 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s2.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s2.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s2.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s2.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s2);

   Scanner s3(COLLATE);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(7 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s3.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s3.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s3);

   Scanner s4(CREATE);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s4);

   Scanner s5(DATETIME);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(8 ,FINAL));
   s5.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s5.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s5.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s5.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s5.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s5.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s5.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s5.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s5);

   Scanner s6(DECIMAL);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(7 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s6.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s6.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s6.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s6.addTransition(ScannerTransEntry(6 ,'l' ,7));
   _scannerList.Insert(s6);

   Scanner s7(DEFAULT);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(7 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s7.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s7.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s7.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s7);

   Scanner s8(DOUBLE);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s8);

   Scanner s9(DROP);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(4 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s9.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s9);

   Scanner s10(ENUM);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s10);

   Scanner s11(ENGINE);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(6 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s11.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s11.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s11);

   Scanner s12(EXISTS);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s12);

   Scanner s13(FALSEVAL);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(5 ,FINAL));
   s13.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s13.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s13.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s13.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s13.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s13);

   Scanner s14(FLOAT);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s14);

   Scanner s15(FOREIGN);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(7 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s15.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s15.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s15.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s15.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s15);

   Scanner s16(IF);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,FINAL));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s16.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s16);

   Scanner s17(INDEX);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(5 ,FINAL));
   s17.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s17.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s17.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s17.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s17.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s17);

   Scanner s18(INT);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addState(ScannerStateEntry(3 ,FINAL));
   s18.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s18.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s18.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s18);

   Scanner s19(INTO);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(4 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s19.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s19);

   Scanner s20(INSERT);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(6 ,FINAL));
   s20.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s20.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s20.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s20.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s20.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s20.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s20);

   Scanner s21(KEY);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s21);

   Scanner s22(LOCK);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(4 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s22.addTransition(ScannerTransEntry(3 ,'k' ,4));
   _scannerList.Insert(s22);

   Scanner s23(LONGBLOB);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(8 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'g' ,4));
   s23.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s23.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s23.addTransition(ScannerTransEntry(6 ,'o' ,7));
   s23.addTransition(ScannerTransEntry(7 ,'b' ,8));
   _scannerList.Insert(s23);

   Scanner s24(MEDIUMTEXT);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(10 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'m' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s24.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s24.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s24.addTransition(ScannerTransEntry(7 ,'e' ,8));
   s24.addTransition(ScannerTransEntry(8 ,'x' ,9));
   s24.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s24);

   Scanner s25(NOT);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s25);

   Scanner s26(NULLTOKEN);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(4 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s26.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s26);

   Scanner s27(PRIMARY);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(7 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s27.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s27.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s27.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s27);

   Scanner s28(SET);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addState(ScannerStateEntry(3 ,FINAL));
   s28.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s28.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s28.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s28);

   Scanner s29(TABLE);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s29);

   Scanner s30(TABLES);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(6 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s30.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s30.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s30.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s30);

   Scanner s31(TEXT);
   s31.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(2 ,START));
   s31.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(4 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s31.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s31.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s31.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s31);

   Scanner s32(TIMESTAMP);
   s32.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(2 ,START));
   s32.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(9 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s32.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s32.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s32.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s32.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s32.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s32.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s32.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s32.addTransition(ScannerTransEntry(8 ,'p' ,9));
   _scannerList.Insert(s32);

   Scanner s33(UNLOCK);
   s33.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(2 ,START));
   s33.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(6 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s33.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s33.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s33.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s33.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s33.addTransition(ScannerTransEntry(5 ,'k' ,6));
   _scannerList.Insert(s33);

   Scanner s34(UNIQUE);
   s34.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(2 ,START));
   s34.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(6 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s34.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s34.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s34.addTransition(ScannerTransEntry(3 ,'q' ,4));
   s34.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s34.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s34);

   Scanner s35(UNSIGNED);
   s35.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(2 ,START));
   s35.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(8 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s35.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s35.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s35.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s35.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s35.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s35.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s35.addTransition(ScannerTransEntry(7 ,'d' ,8));
   _scannerList.Insert(s35);

   Scanner s36(VALUES);
   s36.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(2 ,START));
   s36.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(6 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s36.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s36.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s36.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s36.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s36.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s36);

   Scanner s37(VARCHAR);
   s37.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(2 ,START));
   s37.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(7 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s37.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s37.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s37.addTransition(ScannerTransEntry(4 ,'h' ,5));
   s37.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s37.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s37);

   Scanner s38(WRITE);
   s38.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(2 ,START));
   s38.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(5 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s38.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s38.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s38.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s38);

   Scanner s39(MINUS);
   s39.addState(ScannerStateEntry(0 ,START));
   s39.addState(ScannerStateEntry(1 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s39);

   Scanner s40(EQU);
   s40.addState(ScannerStateEntry(0 ,START));
   s40.addState(ScannerStateEntry(1 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s40);

   Scanner s41(KSEP);
   s41.addState(ScannerStateEntry(0 ,START));
   s41.addState(ScannerStateEntry(1 ,FINAL));
   s41.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s41);

   Scanner s42(LB);
   s42.addState(ScannerStateEntry(0 ,START));
   s42.addState(ScannerStateEntry(1 ,FINAL));
   s42.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s42);

   Scanner s43(RB);
   s43.addState(ScannerStateEntry(0 ,START));
   s43.addState(ScannerStateEntry(1 ,FINAL));
   s43.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s43);

   Scanner s44(SEMICOLON);
   s44.addState(ScannerStateEntry(0 ,START));
   s44.addState(ScannerStateEntry(1 ,FINAL));
   s44.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s44);

   Scanner s45(INTVAL);
   s45.addState(ScannerStateEntry(0 ,START));
   s45.addState(ScannerStateEntry(1 ,FINAL));
   s45.addState(ScannerStateEntry(2 ,FINAL));
   s45.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s45.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s45.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s45.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s45);

   Scanner s46(FLOATVAL);
   s46.addState(ScannerStateEntry(0 ,START));
   s46.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s46.addState(ScannerStateEntry(3 ,FINAL));
   s46.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s46.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s46.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s46.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s46.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s46.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s46);

   Scanner s47(QIDENTIFIER);
   s47.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s47.addState(ScannerStateEntry(2 ,START));
   s47.addState(ScannerStateEntry(3 ,FINAL));
   s47.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s47.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s47.addTransition(ScannerTransEntry(1 ,'`' ,3));
   s47.addTransition(ScannerTransEntry(2 ,'`' ,0));
   _scannerList.Insert(s47);

   Scanner s48(IDENTIFIER);
   s48.addState(ScannerStateEntry(0 ,START));
   s48.addState(ScannerStateEntry(1 ,FINAL));
   s48.addTransition(ScannerTransEntry(0 ,'@' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'@' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'z' ,1));
   _scannerList.Insert(s48);

}
void PostgresParser::loadParser0()
{
   _actionMap[139][UNSIGNED] = ActionEntry(REDUCE, 63);
   _actionMap[139][NULLTOKEN] = ActionEntry(REDUCE, 63);
   _actionMap[139][NOT] = ActionEntry(REDUCE, 63);
   _actionMap[139][DEFAULT] = ActionEntry(REDUCE, 63);
   _actionMap[139][AUTOINCREMENT] = ActionEntry(REDUCE, 63);
   _actionMap[139][RB] = ActionEntry(REDUCE, 63);
   _actionMap[139][KSEP] = ActionEntry(REDUCE, 63);
   _actionMap[133][COLLATE] = ActionEntry(REDUCE, 16);
   _actionMap[133][SEMICOLON] = ActionEntry(REDUCE, 16);
   _actionMap[134][KSEP] = ActionEntry(REDUCE, 35);
   _actionMap[134][RB] = ActionEntry(REDUCE, 35);
   _actionMap[135][KSEP] = ActionEntry(REDUCE, 33);
   _actionMap[135][RB] = ActionEntry(REDUCE, 33);
   _actionMap[136][RB] = ActionEntry(SHIFT, 139);
   _actionMap[137][KSEP] = ActionEntry(REDUCE, 56);
   _actionMap[137][RB] = ActionEntry(REDUCE, 56);
   _actionMap[138][NULLTOKEN] = ActionEntry(REDUCE, 49);
   _actionMap[138][NOT] = ActionEntry(REDUCE, 49);
   _actionMap[138][DEFAULT] = ActionEntry(REDUCE, 49);
   _actionMap[138][AUTOINCREMENT] = ActionEntry(REDUCE, 49);
   _actionMap[138][RB] = ActionEntry(REDUCE, 49);
   _actionMap[138][KSEP] = ActionEntry(REDUCE, 49);
   _actionMap[117][DEFAULT] = ActionEntry(REDUCE, 14);
   _actionMap[117][COLLATE] = ActionEntry(REDUCE, 14);
   _actionMap[117][SEMICOLON] = ActionEntry(REDUCE, 14);
   _actionMap[118][SEMICOLON] = ActionEntry(REDUCE, 18);
   _actionMap[119][IDENTIFIER] = ActionEntry(SHIFT, 133);
   _actionMap[120][AUTOINCREMENT] = ActionEntry(REDUCE, 12);
   _actionMap[120][DEFAULT] = ActionEntry(REDUCE, 12);
   _actionMap[120][COLLATE] = ActionEntry(REDUCE, 12);
   _actionMap[120][SEMICOLON] = ActionEntry(REDUCE, 12);
   _actionMap[121][QIDENTIFIER] = ActionEntry(SHIFT, 134);
   _actionMap[122][KSEP] = ActionEntry(REDUCE, 34);
   _actionMap[122][RB] = ActionEntry(REDUCE, 34);
   _actionMap[123][KSEP] = ActionEntry(REDUCE, 32);
   _actionMap[123][RB] = ActionEntry(REDUCE, 32);
   _actionMap[124][RB] = ActionEntry(SHIFT, 135);
   _actionMap[124][KSEP] = ActionEntry(SHIFT, 121);
   _actionMap[125][KSEP] = ActionEntry(REDUCE, 22);
   _actionMap[125][RB] = ActionEntry(REDUCE, 22);
   _actionMap[126][KSEP] = ActionEntry(REDUCE, 30);
   _actionMap[126][RB] = ActionEntry(REDUCE, 30);
   _actionMap[127][AUTOINCREMENT] = ActionEntry(REDUCE, 27);
   _actionMap[127][RB] = ActionEntry(REDUCE, 27);
   _actionMap[127][KSEP] = ActionEntry(REDUCE, 27);
   _actionMap[128][INTVAL] = ActionEntry(SHIFT, 136);
   _actionMap[129][INTVAL] = ActionEntry(SHIFT, 44);
   _actionMap[129][MINUS] = ActionEntry(SHIFT, 43);
   _actionMap[129][STRINGVAL] = ActionEntry(SHIFT, 41);
   _actionMap[129][NULLTOKEN] = ActionEntry(SHIFT, 42);
}
void PostgresParser::loadParser1()
{
   _jumpMap[129][Constant] = 137;
   _actionMap[130][NULLTOKEN] = ActionEntry(REDUCE, 55);
   _actionMap[130][NOT] = ActionEntry(REDUCE, 55);
   _actionMap[130][DEFAULT] = ActionEntry(REDUCE, 55);
   _actionMap[130][AUTOINCREMENT] = ActionEntry(REDUCE, 55);
   _actionMap[130][RB] = ActionEntry(REDUCE, 55);
   _actionMap[130][KSEP] = ActionEntry(REDUCE, 55);
   _actionMap[131][UNSIGNED] = ActionEntry(REDUCE, 62);
   _actionMap[131][NULLTOKEN] = ActionEntry(REDUCE, 62);
   _actionMap[131][NOT] = ActionEntry(REDUCE, 62);
   _actionMap[131][DEFAULT] = ActionEntry(REDUCE, 62);
   _actionMap[131][AUTOINCREMENT] = ActionEntry(REDUCE, 62);
   _actionMap[131][RB] = ActionEntry(REDUCE, 62);
   _actionMap[131][KSEP] = ActionEntry(REDUCE, 62);
   _actionMap[132][COLLATE] = ActionEntry(SHIFT, 93);
   _actionMap[132][NULLTOKEN] = ActionEntry(REDUCE, 67);
   _actionMap[132][NOT] = ActionEntry(REDUCE, 67);
   _actionMap[132][DEFAULT] = ActionEntry(REDUCE, 67);
   _actionMap[132][AUTOINCREMENT] = ActionEntry(REDUCE, 67);
   _actionMap[132][RB] = ActionEntry(REDUCE, 67);
   _actionMap[132][KSEP] = ActionEntry(REDUCE, 67);
   _jumpMap[132][CollateOpt] = 138;
   _actionMap[96][INTVAL] = ActionEntry(SHIFT, 117);
   _actionMap[97][IDENTIFIER] = ActionEntry(SHIFT, 118);
   _actionMap[98][EQU] = ActionEntry(SHIFT, 119);
   _actionMap[99][IDENTIFIER] = ActionEntry(SHIFT, 120);
   _actionMap[100][RB] = ActionEntry(SHIFT, 122);
   _actionMap[100][KSEP] = ActionEntry(SHIFT, 121);
   _actionMap[101][KSEP] = ActionEntry(REDUCE, 36);
   _actionMap[101][RB] = ActionEntry(REDUCE, 36);
   _actionMap[102][RB] = ActionEntry(SHIFT, 123);
   _actionMap[102][KSEP] = ActionEntry(SHIFT, 121);
   _actionMap[103][QIDENTIFIER] = ActionEntry(SHIFT, 101);
   _jumpMap[103][KeyList] = 124;
   _actionMap[104][AUTOINCREMENT] = ActionEntry(SHIFT, 126);
   _actionMap[104][KSEP] = ActionEntry(REDUCE, 31);
   _actionMap[104][RB] = ActionEntry(REDUCE, 31);
   _jumpMap[104][IncrementOpt] = 125;
   _actionMap[105][AUTOINCREMENT] = ActionEntry(REDUCE, 28);
   _actionMap[105][RB] = ActionEntry(REDUCE, 28);
   _actionMap[105][KSEP] = ActionEntry(REDUCE, 28);
   _actionMap[106][INTVAL] = ActionEntry(SHIFT, 44);
   _actionMap[106][MINUS] = ActionEntry(SHIFT, 43);
   _actionMap[106][STRINGVAL] = ActionEntry(SHIFT, 41);
   _actionMap[106][NULLTOKEN] = ActionEntry(SHIFT, 42);
   _jumpMap[106][Constant] = 127;
   _actionMap[107][DEFAULT] = ActionEntry(REDUCE, 24);
   _actionMap[107][AUTOINCREMENT] = ActionEntry(REDUCE, 24);
   _actionMap[107][RB] = ActionEntry(REDUCE, 24);
   _actionMap[107][KSEP] = ActionEntry(REDUCE, 24);
}
void PostgresParser::loadParser2()
{
   _actionMap[108][NULLTOKEN] = ActionEntry(REDUCE, 48);
   _actionMap[108][NOT] = ActionEntry(REDUCE, 48);
   _actionMap[108][DEFAULT] = ActionEntry(REDUCE, 48);
   _actionMap[108][AUTOINCREMENT] = ActionEntry(REDUCE, 48);
   _actionMap[108][RB] = ActionEntry(REDUCE, 48);
   _actionMap[108][KSEP] = ActionEntry(REDUCE, 48);
   _actionMap[109][NULLTOKEN] = ActionEntry(REDUCE, 64);
   _actionMap[109][NOT] = ActionEntry(REDUCE, 64);
   _actionMap[109][DEFAULT] = ActionEntry(REDUCE, 64);
   _actionMap[109][AUTOINCREMENT] = ActionEntry(REDUCE, 64);
   _actionMap[109][RB] = ActionEntry(REDUCE, 64);
   _actionMap[109][KSEP] = ActionEntry(REDUCE, 64);
   _actionMap[110][KSEP] = ActionEntry(SHIFT, 128);
   _actionMap[111][RB] = ActionEntry(SHIFT, 130);
   _actionMap[111][KSEP] = ActionEntry(SHIFT, 129);
   _actionMap[112][KSEP] = ActionEntry(REDUCE, 57);
   _actionMap[112][RB] = ActionEntry(REDUCE, 57);
   _actionMap[113][NULLTOKEN] = ActionEntry(REDUCE, 47);
   _actionMap[113][NOT] = ActionEntry(REDUCE, 47);
   _actionMap[113][DEFAULT] = ActionEntry(REDUCE, 47);
   _actionMap[113][AUTOINCREMENT] = ActionEntry(REDUCE, 47);
   _actionMap[113][RB] = ActionEntry(REDUCE, 47);
   _actionMap[113][KSEP] = ActionEntry(REDUCE, 47);
   _actionMap[114][RB] = ActionEntry(SHIFT, 131);
   _actionMap[115][NULLTOKEN] = ActionEntry(REDUCE, 66);
   _actionMap[115][NOT] = ActionEntry(REDUCE, 66);
   _actionMap[115][DEFAULT] = ActionEntry(REDUCE, 66);
   _actionMap[115][AUTOINCREMENT] = ActionEntry(REDUCE, 66);
   _actionMap[115][RB] = ActionEntry(REDUCE, 66);
   _actionMap[115][KSEP] = ActionEntry(REDUCE, 66);
   _actionMap[116][RB] = ActionEntry(SHIFT, 132);
   _actionMap[70][KSEP] = ActionEntry(REDUCE, 43);
   _actionMap[70][RB] = ActionEntry(REDUCE, 43);
   _actionMap[71][KSEP] = ActionEntry(REDUCE, 20);
   _actionMap[71][RB] = ActionEntry(REDUCE, 20);
   _actionMap[72][AUTOINCREMENT] = ActionEntry(SHIFT, 76);
   _actionMap[72][DEFAULT] = ActionEntry(REDUCE, 15);
   _actionMap[72][COLLATE] = ActionEntry(REDUCE, 15);
   _actionMap[72][SEMICOLON] = ActionEntry(REDUCE, 15);
   _jumpMap[72][TableCollateOpt] = 75;
   _jumpMap[72][TableCharsetOpt] = 74;
   _jumpMap[72][AutoIncrementOpt] = 73;
   _actionMap[73][DEFAULT] = ActionEntry(SHIFT, 78);
   _actionMap[73][COLLATE] = ActionEntry(REDUCE, 17);
   _actionMap[73][SEMICOLON] = ActionEntry(REDUCE, 17);
   _jumpMap[73][TableCollateOpt] = 75;
   _jumpMap[73][TableCharsetOpt] = 74;
   _actionMap[74][COLLATE] = ActionEntry(SHIFT, 77);
   _actionMap[74][SEMICOLON] = ActionEntry(REDUCE, 19);
   _jumpMap[74][TableCollateOpt] = 75;
}
void PostgresParser::loadParser3()
{
   _actionMap[75][SEMICOLON] = ActionEntry(REDUCE, 8);
   _actionMap[76][EQU] = ActionEntry(SHIFT, 96);
   _actionMap[77][EQU] = ActionEntry(SHIFT, 97);
   _actionMap[78][CHARSET] = ActionEntry(SHIFT, 98);
   _actionMap[79][EQU] = ActionEntry(SHIFT, 99);
   _actionMap[80][QIDENTIFIER] = ActionEntry(SHIFT, 101);
   _jumpMap[80][KeyList] = 100;
   _actionMap[81][QIDENTIFIER] = ActionEntry(SHIFT, 101);
   _jumpMap[81][KeyList] = 102;
   _actionMap[82][LB] = ActionEntry(SHIFT, 103);
   _actionMap[83][KSEP] = ActionEntry(REDUCE, 29);
   _actionMap[83][RB] = ActionEntry(REDUCE, 29);
   _actionMap[83][AUTOINCREMENT] = ActionEntry(REDUCE, 29);
   _actionMap[83][DEFAULT] = ActionEntry(SHIFT, 106);
   _jumpMap[83][DefaultDefOpt] = 105;
   _jumpMap[83][DefaultOpt] = 104;
   _actionMap[84][DEFAULT] = ActionEntry(REDUCE, 25);
   _actionMap[84][AUTOINCREMENT] = ActionEntry(REDUCE, 25);
   _actionMap[84][RB] = ActionEntry(REDUCE, 25);
   _actionMap[84][KSEP] = ActionEntry(REDUCE, 25);
   _actionMap[85][NULLTOKEN] = ActionEntry(SHIFT, 107);
   _actionMap[86][DEFAULT] = ActionEntry(REDUCE, 23);
   _actionMap[86][AUTOINCREMENT] = ActionEntry(REDUCE, 23);
   _actionMap[86][RB] = ActionEntry(REDUCE, 23);
   _actionMap[86][KSEP] = ActionEntry(REDUCE, 23);
   _actionMap[87][UNSIGNED] = ActionEntry(SHIFT, 109);
   _actionMap[87][NULLTOKEN] = ActionEntry(REDUCE, 65);
   _actionMap[87][NOT] = ActionEntry(REDUCE, 65);
   _actionMap[87][DEFAULT] = ActionEntry(REDUCE, 65);
   _actionMap[87][AUTOINCREMENT] = ActionEntry(REDUCE, 65);
   _actionMap[87][RB] = ActionEntry(REDUCE, 65);
   _actionMap[87][KSEP] = ActionEntry(REDUCE, 65);
   _jumpMap[87][UnsignedOpt] = 108;
   _actionMap[88][INTVAL] = ActionEntry(SHIFT, 110);
   _actionMap[89][INTVAL] = ActionEntry(SHIFT, 44);
   _actionMap[89][MINUS] = ActionEntry(SHIFT, 43);
   _actionMap[89][STRINGVAL] = ActionEntry(SHIFT, 41);
   _actionMap[89][NULLTOKEN] = ActionEntry(SHIFT, 42);
   _jumpMap[89][Constant] = 112;
   _jumpMap[89][ConstList] = 111;
   _actionMap[90][UNSIGNED] = ActionEntry(SHIFT, 109);
   _actionMap[90][NULLTOKEN] = ActionEntry(REDUCE, 65);
   _actionMap[90][NOT] = ActionEntry(REDUCE, 65);
   _actionMap[90][DEFAULT] = ActionEntry(REDUCE, 65);
   _actionMap[90][AUTOINCREMENT] = ActionEntry(REDUCE, 65);
   _actionMap[90][RB] = ActionEntry(REDUCE, 65);
   _actionMap[90][KSEP] = ActionEntry(REDUCE, 65);
   _jumpMap[90][UnsignedOpt] = 113;
   _actionMap[91][INTVAL] = ActionEntry(SHIFT, 114);
   _actionMap[92][NULLTOKEN] = ActionEntry(REDUCE, 53);
}
void PostgresParser::loadParser4()
{
   _actionMap[92][NOT] = ActionEntry(REDUCE, 53);
   _actionMap[92][DEFAULT] = ActionEntry(REDUCE, 53);
   _actionMap[92][AUTOINCREMENT] = ActionEntry(REDUCE, 53);
   _actionMap[92][RB] = ActionEntry(REDUCE, 53);
   _actionMap[92][KSEP] = ActionEntry(REDUCE, 53);
   _actionMap[93][IDENTIFIER] = ActionEntry(SHIFT, 115);
   _actionMap[94][NULLTOKEN] = ActionEntry(REDUCE, 54);
   _actionMap[94][NOT] = ActionEntry(REDUCE, 54);
   _actionMap[94][DEFAULT] = ActionEntry(REDUCE, 54);
   _actionMap[94][AUTOINCREMENT] = ActionEntry(REDUCE, 54);
   _actionMap[94][RB] = ActionEntry(REDUCE, 54);
   _actionMap[94][KSEP] = ActionEntry(REDUCE, 54);
   _actionMap[95][INTVAL] = ActionEntry(SHIFT, 116);
   _actionMap[51][SEMICOLON] = ActionEntry(REDUCE, 40);
   _actionMap[51][KSEP] = ActionEntry(REDUCE, 40);
   _actionMap[52][INTVAL] = ActionEntry(SHIFT, 44);
   _actionMap[52][MINUS] = ActionEntry(SHIFT, 43);
   _actionMap[52][STRINGVAL] = ActionEntry(SHIFT, 41);
   _actionMap[52][NULLTOKEN] = ActionEntry(SHIFT, 42);
   _jumpMap[52][Constant] = 70;
   _actionMap[53][SEMICOLON] = ActionEntry(REDUCE, 42);
   _actionMap[53][KSEP] = ActionEntry(REDUCE, 42);
   _actionMap[54][AUTOINCREMENT] = ActionEntry(REDUCE, 59);
   _actionMap[54][RB] = ActionEntry(REDUCE, 59);
   _actionMap[54][KSEP] = ActionEntry(REDUCE, 59);
   _actionMap[55][QIDENTIFIER] = ActionEntry(SHIFT, 50);
   _actionMap[55][PRIMARY] = ActionEntry(SHIFT, 48);
   _actionMap[55][UNIQUE] = ActionEntry(SHIFT, 49);
   _actionMap[55][KEY] = ActionEntry(SHIFT, 47);
   _jumpMap[55][ColumnDesc] = 71;
   _actionMap[56][ENGINE] = ActionEntry(SHIFT, 79);
   _actionMap[56][AUTOINCREMENT] = ActionEntry(REDUCE, 13);
   _actionMap[56][DEFAULT] = ActionEntry(REDUCE, 13);
   _actionMap[56][COLLATE] = ActionEntry(REDUCE, 13);
   _actionMap[56][SEMICOLON] = ActionEntry(REDUCE, 13);
   _jumpMap[56][TableCollateOpt] = 75;
   _jumpMap[56][TableCharsetOpt] = 74;
   _jumpMap[56][AutoIncrementOpt] = 73;
   _jumpMap[56][EngineOpt] = 72;
   _actionMap[57][LB] = ActionEntry(SHIFT, 80);
   _actionMap[58][LB] = ActionEntry(SHIFT, 81);
   _actionMap[59][QIDENTIFIER] = ActionEntry(SHIFT, 82);
   _actionMap[60][KSEP] = ActionEntry(REDUCE, 26);
   _actionMap[60][RB] = ActionEntry(REDUCE, 26);
   _actionMap[60][AUTOINCREMENT] = ActionEntry(REDUCE, 26);
   _actionMap[60][DEFAULT] = ActionEntry(REDUCE, 26);
   _actionMap[60][NULLTOKEN] = ActionEntry(SHIFT, 86);
   _actionMap[60][NOT] = ActionEntry(SHIFT, 85);
   _jumpMap[60][DefaultNullOpt] = 84;
   _jumpMap[60][NullOpt] = 83;
}
void PostgresParser::loadParser5()
{
   _actionMap[61][NULLTOKEN] = ActionEntry(REDUCE, 51);
   _actionMap[61][NOT] = ActionEntry(REDUCE, 51);
   _actionMap[61][DEFAULT] = ActionEntry(REDUCE, 51);
   _actionMap[61][AUTOINCREMENT] = ActionEntry(REDUCE, 51);
   _actionMap[61][RB] = ActionEntry(REDUCE, 51);
   _actionMap[61][KSEP] = ActionEntry(REDUCE, 51);
   _actionMap[62][LB] = ActionEntry(SHIFT, 88);
   _jumpMap[62][DecimalDimOpt] = 87;
   _actionMap[63][LB] = ActionEntry(SHIFT, 89);
   _actionMap[64][LB] = ActionEntry(SHIFT, 91);
   _jumpMap[64][DimOpt] = 90;
   _actionMap[65][NULLTOKEN] = ActionEntry(REDUCE, 52);
   _actionMap[65][NOT] = ActionEntry(REDUCE, 52);
   _actionMap[65][DEFAULT] = ActionEntry(REDUCE, 52);
   _actionMap[65][AUTOINCREMENT] = ActionEntry(REDUCE, 52);
   _actionMap[65][RB] = ActionEntry(REDUCE, 52);
   _actionMap[65][KSEP] = ActionEntry(REDUCE, 52);
   _actionMap[66][COLLATE] = ActionEntry(SHIFT, 93);
   _actionMap[66][NULLTOKEN] = ActionEntry(REDUCE, 67);
   _actionMap[66][NOT] = ActionEntry(REDUCE, 67);
   _actionMap[66][DEFAULT] = ActionEntry(REDUCE, 67);
   _actionMap[66][AUTOINCREMENT] = ActionEntry(REDUCE, 67);
   _actionMap[66][RB] = ActionEntry(REDUCE, 67);
   _actionMap[66][KSEP] = ActionEntry(REDUCE, 67);
   _jumpMap[66][CollateOpt] = 92;
   _actionMap[67][COLLATE] = ActionEntry(SHIFT, 93);
   _actionMap[67][NULLTOKEN] = ActionEntry(REDUCE, 67);
   _actionMap[67][NOT] = ActionEntry(REDUCE, 67);
   _actionMap[67][DEFAULT] = ActionEntry(REDUCE, 67);
   _actionMap[67][AUTOINCREMENT] = ActionEntry(REDUCE, 67);
   _actionMap[67][RB] = ActionEntry(REDUCE, 67);
   _actionMap[67][KSEP] = ActionEntry(REDUCE, 67);
   _jumpMap[67][CollateOpt] = 94;
   _actionMap[68][NULLTOKEN] = ActionEntry(REDUCE, 50);
   _actionMap[68][NOT] = ActionEntry(REDUCE, 50);
   _actionMap[68][DEFAULT] = ActionEntry(REDUCE, 50);
   _actionMap[68][AUTOINCREMENT] = ActionEntry(REDUCE, 50);
   _actionMap[68][RB] = ActionEntry(REDUCE, 50);
   _actionMap[68][KSEP] = ActionEntry(REDUCE, 50);
   _actionMap[69][LB] = ActionEntry(SHIFT, 95);
   _actionMap[38][LB] = ActionEntry(SHIFT, 33);
   _jumpMap[38][InsertValueSpec] = 51;
   _actionMap[39][RB] = ActionEntry(SHIFT, 53);
   _actionMap[39][KSEP] = ActionEntry(SHIFT, 52);
   _actionMap[40][KSEP] = ActionEntry(REDUCE, 44);
   _actionMap[40][RB] = ActionEntry(REDUCE, 44);
   _actionMap[41][AUTOINCREMENT] = ActionEntry(REDUCE, 60);
   _actionMap[41][KSEP] = ActionEntry(REDUCE, 60);
   _actionMap[41][RB] = ActionEntry(REDUCE, 60);
   _actionMap[42][AUTOINCREMENT] = ActionEntry(REDUCE, 61);
}
void PostgresParser::loadParser6()
{
   _actionMap[42][RB] = ActionEntry(REDUCE, 61);
   _actionMap[42][KSEP] = ActionEntry(REDUCE, 61);
   _actionMap[43][INTVAL] = ActionEntry(SHIFT, 54);
   _actionMap[44][AUTOINCREMENT] = ActionEntry(REDUCE, 58);
   _actionMap[44][KSEP] = ActionEntry(REDUCE, 58);
   _actionMap[44][RB] = ActionEntry(REDUCE, 58);
   _actionMap[45][RB] = ActionEntry(SHIFT, 56);
   _actionMap[45][KSEP] = ActionEntry(SHIFT, 55);
   _actionMap[46][KSEP] = ActionEntry(REDUCE, 21);
   _actionMap[46][RB] = ActionEntry(REDUCE, 21);
   _actionMap[47][QIDENTIFIER] = ActionEntry(SHIFT, 57);
   _actionMap[48][KEY] = ActionEntry(SHIFT, 58);
   _actionMap[49][KEY] = ActionEntry(SHIFT, 59);
   _actionMap[50][INT] = ActionEntry(SHIFT, 64);
   _actionMap[50][DECIMAL] = ActionEntry(SHIFT, 62);
   _actionMap[50][VARCHAR] = ActionEntry(SHIFT, 69);
   _actionMap[50][TIMESTAMP] = ActionEntry(SHIFT, 68);
   _actionMap[50][DATETIME] = ActionEntry(SHIFT, 61);
   _actionMap[50][LONGBLOB] = ActionEntry(SHIFT, 65);
   _actionMap[50][MEDIUMTEXT] = ActionEntry(SHIFT, 66);
   _actionMap[50][TEXT] = ActionEntry(SHIFT, 67);
   _actionMap[50][ENUM] = ActionEntry(SHIFT, 63);
   _jumpMap[50][DataTypeProd] = 60;
   _actionMap[31][KSEP] = ActionEntry(SHIFT, 38);
   _actionMap[31][SEMICOLON] = ActionEntry(REDUCE, 39);
   _actionMap[32][SEMICOLON] = ActionEntry(REDUCE, 41);
   _actionMap[32][KSEP] = ActionEntry(REDUCE, 41);
   _actionMap[33][INTVAL] = ActionEntry(SHIFT, 44);
   _actionMap[33][MINUS] = ActionEntry(SHIFT, 43);
   _actionMap[33][STRINGVAL] = ActionEntry(SHIFT, 41);
   _actionMap[33][NULLTOKEN] = ActionEntry(SHIFT, 42);
   _jumpMap[33][Constant] = 40;
   _jumpMap[33][InsertValueList] = 39;
   _actionMap[34][QIDENTIFIER] = ActionEntry(SHIFT, 50);
   _actionMap[34][PRIMARY] = ActionEntry(SHIFT, 48);
   _actionMap[34][UNIQUE] = ActionEntry(SHIFT, 49);
   _actionMap[34][KEY] = ActionEntry(SHIFT, 47);
   _jumpMap[34][ColumnDesc] = 46;
   _jumpMap[34][ColumnList] = 45;
   _actionMap[35][QIDENTIFIER] = ActionEntry(REDUCE, 11);
   _actionMap[36][SEMICOLON] = ActionEntry(REDUCE, 37);
   _actionMap[37][SEMICOLON] = ActionEntry(REDUCE, 4);
   _actionMap[25][SEMICOLON] = ActionEntry(REDUCE, 1);
   _actionMap[25][SET] = ActionEntry(REDUCE, 1);
   _actionMap[25][CREATE] = ActionEntry(REDUCE, 1);
   _actionMap[25][DROP] = ActionEntry(REDUCE, 1);
   _actionMap[25][UNLOCK] = ActionEntry(REDUCE, 1);
   _actionMap[25][LOCK] = ActionEntry(REDUCE, 1);
   _actionMap[25][INSERT] = ActionEntry(REDUCE, 1);
   _actionMap[25][ENDTOKEN] = ActionEntry(REDUCE, 1);
}
void PostgresParser::loadParser7()
{
   _actionMap[26][LB] = ActionEntry(SHIFT, 33);
   _jumpMap[26][InsertValueSpec] = 32;
   _jumpMap[26][InsertValueSpecList] = 31;
   _actionMap[27][LB] = ActionEntry(SHIFT, 34);
   _actionMap[28][EXISTS] = ActionEntry(SHIFT, 35);
   _actionMap[29][WRITE] = ActionEntry(SHIFT, 36);
   _actionMap[30][IDENTIFIER] = ActionEntry(SHIFT, 37);
   _actionMap[14][SEMICOLON] = ActionEntry(SHIFT, 25);
   _actionMap[15][SEMICOLON] = ActionEntry(REDUCE, 2);
   _actionMap[15][SET] = ActionEntry(REDUCE, 2);
   _actionMap[15][CREATE] = ActionEntry(REDUCE, 2);
   _actionMap[15][DROP] = ActionEntry(REDUCE, 2);
   _actionMap[15][UNLOCK] = ActionEntry(REDUCE, 2);
   _actionMap[15][LOCK] = ActionEntry(REDUCE, 2);
   _actionMap[15][INSERT] = ActionEntry(REDUCE, 2);
   _actionMap[15][ENDTOKEN] = ActionEntry(REDUCE, 2);
   _actionMap[16][SEMICOLON] = ActionEntry(REDUCE, 9);
   _actionMap[17][VALUES] = ActionEntry(REDUCE, 46);
   _actionMap[17][SEMICOLON] = ActionEntry(REDUCE, 46);
   _actionMap[17][LB] = ActionEntry(REDUCE, 46);
   _actionMap[18][VALUES] = ActionEntry(SHIFT, 26);
   _actionMap[19][QIDENTIFIER] = ActionEntry(SHIFT, 17);
   _jumpMap[19][Table] = 27;
   _actionMap[20][IF] = ActionEntry(SHIFT, 28);
   _actionMap[20][QIDENTIFIER] = ActionEntry(REDUCE, 10);
   _actionMap[21][QIDENTIFIER] = ActionEntry(REDUCE, 45);
   _actionMap[22][QIDENTIFIER] = ActionEntry(SHIFT, 29);
   _actionMap[23][EQU] = ActionEntry(SHIFT, 30);
   _actionMap[24][SEMICOLON] = ActionEntry(REDUCE, 38);
   _actionMap[1][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[1][INSERT] = ActionEntry(SHIFT, 10);
   _actionMap[1][DROP] = ActionEntry(SHIFT, 9);
   _actionMap[1][UNLOCK] = ActionEntry(SHIFT, 13);
   _actionMap[1][LOCK] = ActionEntry(SHIFT, 11);
   _actionMap[1][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[1][SET] = ActionEntry(SHIFT, 12);
   _actionMap[1][CREATE] = ActionEntry(SHIFT, 8);
   _jumpMap[1][InsertPrefix] = 7;
   _jumpMap[1][InsertStatement] = 6;
   _jumpMap[1][UnlockStatement] = 5;
   _jumpMap[1][LockStatement] = 4;
   _jumpMap[1][DropOpt] = 3;
   _jumpMap[1][Statement] = 14;
   _actionMap[2][SEMICOLON] = ActionEntry(SHIFT, 15);
   _actionMap[3][QIDENTIFIER] = ActionEntry(SHIFT, 17);
   _jumpMap[3][Table] = 16;
   _actionMap[4][SEMICOLON] = ActionEntry(REDUCE, 6);
   _actionMap[5][SEMICOLON] = ActionEntry(REDUCE, 7);
   _actionMap[6][SEMICOLON] = ActionEntry(REDUCE, 5);
   _actionMap[7][QIDENTIFIER] = ActionEntry(SHIFT, 17);
}
void PostgresParser::loadParser8()
{
   _jumpMap[7][Table] = 18;
   _actionMap[8][TABLE] = ActionEntry(SHIFT, 19);
   _actionMap[9][TABLE] = ActionEntry(SHIFT, 20);
   _actionMap[10][INTO] = ActionEntry(SHIFT, 21);
   _actionMap[11][TABLES] = ActionEntry(SHIFT, 22);
   _actionMap[12][IDENTIFIER] = ActionEntry(SHIFT, 23);
   _actionMap[13][TABLES] = ActionEntry(SHIFT, 24);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 10);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 9);
   _actionMap[0][UNLOCK] = ActionEntry(SHIFT, 13);
   _actionMap[0][LOCK] = ActionEntry(SHIFT, 11);
   _actionMap[0][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[0][SET] = ActionEntry(SHIFT, 12);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 8);
   _jumpMap[0][InsertPrefix] = 7;
   _jumpMap[0][InsertStatement] = 6;
   _jumpMap[0][UnlockStatement] = 5;
   _jumpMap[0][LockStatement] = 4;
   _jumpMap[0][DropOpt] = 3;
   _jumpMap[0][Statement] = 2;
   _jumpMap[0][StatementList] = 1;
}
void PostgresParser::loadParser9()
{
   _prodInfo.Insert(ProdEntry(67, CollateOpt, 0));
   _prodInfo.Insert(ProdEntry(66, CollateOpt, 2));
   _prodInfo.Insert(ProdEntry(65, UnsignedOpt, 0));
   _prodInfo.Insert(ProdEntry(64, UnsignedOpt, 1));
   _prodInfo.Insert(ProdEntry(63, DecimalDimOpt, 5));
   _prodInfo.Insert(ProdEntry(62, DimOpt, 3));
   _prodInfo.Insert(ProdEntry(61, Constant, 1));
   _prodInfo.Insert(ProdEntry(60, Constant, 1));
   _prodInfo.Insert(ProdEntry(59, Constant, 2));
   _prodInfo.Insert(ProdEntry(58, Constant, 1));
   _prodInfo.Insert(ProdEntry(57, ConstList, 1));
   _prodInfo.Insert(ProdEntry(56, ConstList, 3));
   _prodInfo.Insert(ProdEntry(55, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(54, DataTypeProd, 2));
   _prodInfo.Insert(ProdEntry(53, DataTypeProd, 2));
   _prodInfo.Insert(ProdEntry(52, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(51, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(50, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(49, DataTypeProd, 5));
   _prodInfo.Insert(ProdEntry(48, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(47, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(46, Table, 1));
   _prodInfo.Insert(ProdEntry(45, InsertPrefix, 2));
   _prodInfo.Insert(ProdEntry(44, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(43, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(42, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(41, InsertValueSpecList, 1));
   _prodInfo.Insert(ProdEntry(40, InsertValueSpecList, 3));
   _prodInfo.Insert(ProdEntry(39, InsertStatement, 4));
   _prodInfo.Insert(ProdEntry(38, UnlockStatement, 2));
   _prodInfo.Insert(ProdEntry(37, LockStatement, 4));
   _prodInfo.Insert(ProdEntry(36, KeyList, 1));
   _prodInfo.Insert(ProdEntry(35, KeyList, 3));
   _prodInfo.Insert(ProdEntry(34, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(33, ColumnDesc, 6));
   _prodInfo.Insert(ProdEntry(32, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(31, IncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(30, IncrementOpt, 1));
   _prodInfo.Insert(ProdEntry(29, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(28, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(27, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(26, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(25, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(24, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(23, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(22, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(21, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(20, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(19, TableCollateOpt, 0));
   _prodInfo.Insert(ProdEntry(18, TableCollateOpt, 3));
   _prodInfo.Insert(ProdEntry(17, TableCharsetOpt, 0));
   _prodInfo.Insert(ProdEntry(16, TableCharsetOpt, 4));
   _prodInfo.Insert(ProdEntry(15, AutoIncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(14, AutoIncrementOpt, 3));
   _prodInfo.Insert(ProdEntry(13, EngineOpt, 0));
   _prodInfo.Insert(ProdEntry(12, EngineOpt, 3));
   _prodInfo.Insert(ProdEntry(11, DropOpt, 4));
   _prodInfo.Insert(ProdEntry(10, DropOpt, 2));
   _prodInfo.Insert(ProdEntry(9, Statement, 2));
   _prodInfo.Insert(ProdEntry(8, Statement, 10));
   _prodInfo.Insert(ProdEntry(7, Statement, 1));
   _prodInfo.Insert(ProdEntry(6, Statement, 1));
   _prodInfo.Insert(ProdEntry(5, Statement, 1));
   _prodInfo.Insert(ProdEntry(4, Statement, 4));
   _prodInfo.Insert(ProdEntry(3, Statement, 0));
   _prodInfo.Insert(ProdEntry(2, StatementList, 2));
   _prodInfo.Insert(ProdEntry(1, StatementList, 3));
   _prodInfo.Insert(ProdEntry(0, Start, 1));
}

PostgresParser::PostgresParser()
{
   loadScanner();
   for ( int i=0; i < 140; i++)
   {
      int j;
      for ( j = 0; j < 51; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 32; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   loadParser7();
   loadParser8();
   loadParser9();
   _isReserved = false;
}

PostgresParser::~PostgresParser()
{
}

void PostgresParser::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 64:
                     storeUnsignedType();
                     break;
                  case 63:
                     storeDecimalDim();
                     break;
                  case 62:
                     storeDim();
                     break;
                  case 61:
                     storeNullValue();
                     break;
                  case 60:
                     storeVarcharValue();
                     break;
                  case 59:
                     storeNegIntValue();
                     break;
                  case 58:
                     storeIntValue();
                     break;
                  case 55:
                     storeEnumType();
                     break;
                  case 54:
                     storeMediumTextType();
                     break;
                  case 53:
                     storeMediumTextType();
                     break;
                  case 51:
                     storeDatetimeType();
                     break;
                  case 50:
                     storeTimestampType();
                     break;
                  case 49:
                     storeVarcharType();
                     break;
                  case 48:
                     storeDecimalType();
                     break;
                  case 47:
                     storeIntType();
                     break;
                  case 46:
                     storeTable();
                     break;
                  case 45:
                     insertPreAction();
                     break;
                  case 44:
                     insertConstValue();
                     break;
                  case 43:
                     insertConstValue();
                     break;
                  case 42:
                     execInsert();
                     break;
                  case 39:
                     insertPostAction();
                     break;
                  case 36:
                     storeKeyColumn();
                     break;
                  case 35:
                     storeKeyColumn();
                     break;
                  case 34:
                     storeKey();
                     break;
                  case 33:
                     storeUniqueKey();
                     break;
                  case 32:
                     storePrimaryKey();
                     break;
                  case 28:
                     storeDefaultNullOpt();
                     break;
                  case 27:
                     storeDefaultOpt();
                     break;
                  case 25:
                     storeNullOpt();
                     break;
                  case 24:
                     storeNotNullOpt();
                     break;
                  case 23:
                     storeNullOpt();
                     break;
                  case 22:
                     storeAttrColumn();
                     break;
                  case 11:
                     dropOpt2();
                     break;
                  case 10:
                     dropOpt1();
                     break;
                  case 9:
                     execDrop();
                     break;
                  case 8:
                     execCreate();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               postAction();
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool PostgresParser::getAction(int state, PostgresParser::Token token, PostgresParser::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool PostgresParser::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool PostgresParser::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   return false;
}
bool PostgresParser::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   if (c == '\r') return true;
   return false;
}
bool PostgresParser::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void PostgresParser::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
